Third-Party Tools Supported by Cockroach Labs

On this page Carat arrow pointing down
Warning:
Cockroach Labs will stop providing Assistance Support for v23.1 on November 15, 2024. Prior to that date, upgrade to a more recent version to continue receiving support. For more details, refer to the Release Support Policy.

CockroachDB's support of the PostgreSQL wire protocol makes most PostgreSQL drivers, ORM frameworks, and other types of third-party database tools designed for PostgreSQL compatible with CockroachDB. Cockroach Labs guarantees official support for a set of popular PostgreSQL tools, which we list on this page.

Support levels

Cockroach Labs has partnered with open-source projects, vendors, and individuals to offer the following levels of support with third-party tools:

  • Full support indicates that Cockroach Labs is committed to maintaining compatibility with the vast majority of the tool's features. CockroachDB is regularly tested against the latest version documented in the table below.
  • Partial support indicates that Cockroach Labs is working towards full support for the tool. The primary features of the tool are compatible with CockroachDB (e.g., connecting and basic database operations), but full integration may require additional steps, lack support for all features, or exhibit unexpected behavior.
  • Partner supported indicates that Cockroach Labs has a partnership with a third-party vendor that provides support for the CockroachDB integration with their tool.
Warning:

Tools, drivers, or frameworks are considered unsupported if:

  • The tool, driver, or framework is not listed on this page.
  • The version of a supported tool, driver, or framework is not listed on this page.

If you encounter issues when using unsupported tools, drivers, or frameworks, contact the maintainer directly.

Cockroach Labs provides "best effort" support for tools, drivers, and frameworks that are not officially supported. This means that while we will do our best to assist you, we may not be able to fully troubleshoot errors in your deployment.

Customers should contact their account team before moving production workloads to CockroachDB that use unsupported drivers.

Note:

Unless explicitly stated, support for a driver or data access framework does not include automatic, client-side transaction retry handling. For client-side transaction retry handling samples, see Example Apps.

If you encounter problems using CockroachDB with any of the tools listed on this page, please open an issue with details to help us make progress toward better support.

For a list of tools supported by the CockroachDB community, see Third-Party Tools Supported by the Community.

Drivers

Language Driver Latest tested version Support level CockroachDB adapter Tutorial
C libpq PostgreSQL 13 Partial N/A N/A
C# (.NET) Npgsql 7.0.2 Full N/A Build a C# App with CockroachDB (Npgsql)
Go pgx


pq
v5.3.1
(use latest version of CockroachDB adapter)
v1.10.5
Full


Full
crdbpgx
(includes client-side transaction retry handling)
N/A
Build a Go App with CockroachDB (pgx)


Build a Go App with CockroachDB (pq)
Java JDBC REL42.3.3 Full N/A Build a Java App with CockroachDB (JDBC)
JavaScript pg 8.2.1 Full N/A Build a Node.js App with CockroachDB (pg)
Python psycopg3


psycopg2


asyncpg
3.0.16


2.8.6


v0.24.0
Full


Full


Partial
N/A


N/A


N/A
Build a Python App with CockroachDB (psycopg3)


Build a Python App with CockroachDB (psycopg2)


Build a Python App with CockroachDB (asyncpg)
Ruby pg v1.4.6 Full N/A Build a Ruby App with CockroachDB (pg)
Rust rust-postgres 0.19.2 Partial N/A Build a Rust App with CockroachDB

Data access frameworks (e.g., ORMs)

Language Framework Latest tested version Support level CockroachDB adapter Tutorial
Go GORM


go-pg
upper/db
v1.24.1


v10.9.0
v4
Full


Full
Full
crdbgorm
(includes client-side transaction retry handling)
N/A
N/A
Build a Go App with CockroachDB (GORM)


N/A
Build a Go App with CockroachDB (upper/db)
Java Hibernate
(including Hibernate Spatial)
jOOQ
MyBatis
6.3.1 (must be at least 5.4.19)


3.13.2 (must be at least 3.13.0)
3.5.5
Full


Full
Full
N/A


N/A
N/A
Build a Java App with CockroachDB (Hibernate)


Build a Java App with CockroachDB (jOOQ)
Build a Spring App with CockroachDB (MyBatis)
JavaScript/TypeScript Sequelize


Knex.js
Prisma
TypeORM
v6.0.5
(use latest version of CockroachDB adapter)
2.5.1
3.14.0
0.3.17
Full


Full
Full
Full
sequelize-cockroachdb


N/A
N/A
N/A
Build a Node.js App with CockroachDB (Sequelize)


Build a Node.js App with CockroachDB (Knex.js)
Build a Node.js App with CockroachDB (Prisma)
Build a TypeScript App with CockroachDB (TypeORM)
Ruby ActiveRecord
RGeo/RGeo-ActiveRecord
7.1.3
(use latest version of CockroachDB adapter)
Full activerecord-cockroachdb-adapter
(includes client-side transaction retry handling)
Build a Ruby App with CockroachDB (ActiveRecord)
Python Django
(including GeoDjango)
peewee
SQLAlchemy
4.1.x
(use latest version of CockroachDB adapter)

3.13.3
0.7.13
1.4.17
(use latest version of CockroachDB adapter)
Full


Full
Full
Full
django-cockroachdb


N/A
N/A
sqlalchemy-cockroachdb
(includes client-side transaction retry handling)
Build a Python App with CockroachDB (Django)


N/A (See peewee docs.)
Build a Python App with CockroachDB (SQLAlchemy)

Application frameworks

Framework Data access Latest tested version Support level Tutorial
Spring JDBC
JPA (Hibernate)
MyBatis
See individual Java ORM or driver for data access version support. See individual Java ORM or driver for data access support level. Build a Spring App with CockroachDB (JDBC)
Build a Spring App with CockroachDB (JPA)
Build a Spring App with CockroachDB (MyBatis)

Graphical user interfaces (GUIs)

GUI Latest tested version Support level Tutorial
DBeaver 5.2.3 Full Visualize CockroachDB Schemas with DBeaver

Integrated development environments (IDEs)

IDE Latest tested version Support level Tutorial
DataGrip 2024.1 Full N/A
IntelliJ IDEA 2024.1 Full Use IntelliJ IDEA with CockroachDB

Enhanced data security tools

Tool Support level Integration
Satori Partner supported Satori Integration
HashiCorp Vault Partner supported HashiCorp Vault Integration

Schema migration tools

Tool Latest tested version Support level Tutorial
Alembic 1.7 Full Migrate CockroachDB Schemas with Alembic
Flyway 7.1.0 Full Migrate CockroachDB Schemas with Flyway
Liquibase 4.2.0 Full Migrate CockroachDB Schemas with Liquibase
Prisma 3.14.0 Full Build a Node.js App with CockroachDB (Prisma)

Data migration tools

Tool Latest tested version Support level Documentation
AWS DMS 3.4.6 Full Migrate with AWS Database Migration Service (DMS)
Qlik Replicate November 2022 Full Migrate and Replicate Data with Qlik Replicate
Striim 4.1.2 Full Migrate and Replicate Data with Striim
Oracle GoldenGate 21.3 Partial Migrate and Replicate Data with Oracle GoldenGate
Debezium 2.4 Full Migrate Data with Debezium

Provisioning tools

Tool Latest tested version Support level Documentation
Terraform 1.3.2 Partial Terraform provider for CockroachDB Cloud

Other tools

Tool Latest tested version Support level Tutorial
Flowable 6.4.2 Full Getting Started with Flowable and CockroachDB (external)

See also


Yes No
On this page

Yes No